# DRIP backend fake certification server.
Requirements:
python 3.7+
Docker client(e.g. docker desktop)
Microsoft Visual C++ 14+

##setup
1. create venv: python -m venv venv_name   
2. activate venv:  
2.1: on windows: venv_name\Scripts\activate  
2.2: on linux: venv_name/bin/activate  (or source venv_name/bin/activate)
3. install requirements: pip install -r requirements

In case of permission errors  sudo chmod 666 /var/run/docker.sock

#RUN
Use the run.py to start the server.  
EX: python run.py OR python run.py --mode START  
If you need to stop the server or restart it simply add
the flag --mode STOP/RESTART.  
EX 1: python run.py --mode STOP  
EX 2: python run.py --mode RESTART  

Remove mysql-storage/ to reset db (must be done if changes are done to init.sql)

Running the server will create a website at localhost:8080 that
can register drones.

If you don't want the hassle of either the website or entering the database through
the given address you can also run the created_requests.py file. It will prompt you for
what you want to do, giving all current options you can do on the
database.

Worth noting is that the server runs https with a selfcertified certificate. This certificate
will expire sometime in 2022 so if issues occurs it might be worth checking the certificate or creating
a new one.

#Example requests
GET localhost:5000/get/drones/all

POST localhost:5000/get/drones
{
    "drip_ids": ["drip_id_1_abc123", "drip_id_2_def456"]
}

POST localhost:5000/insert/drone
{
    "drip_id": "drip_id_1_abc123",
    "model": "fast drone 2000",
    "owner_name": "Johnny Cameron",
    "pub_key": "AIZA456890sdfg45y0dbfkmlh5"
    "lat": 51.23,
    "lon": 12.33
}
#Enter database
To connect to MySQL db using PHPMyAdmin:
- Go to localhost:8183
- Enter the following:
db
root
root
