import requests
"""
Contains methods to communicate with database.
"""


def insert_drone():
    """
    Prompt for necessary information and inserts a drone into the database.
    Prints response status and content.
    """
    drip_id = input("enter drip id: ")
    model = input("Enter model: ")
    owner = input("Enter owner: ")
    pub_key = input("Enter public key: ")
    latitude = input("Enter latitude: ")
    longitude = input("Enter longitude: ")
    payload_dict = {"drip_id": drip_id, "model": model, "owner_name": owner, "pub_key":pub_key, "lat":latitude, "lon": longitude}
    r1 = requests.post('https://localhost:8080/insert/drone', json=payload_dict, verify=False)

    print(r1.status_code)
    print(r1.content)


def get_drones():
    """
    Fetches specified drones from database and prints the response.
    """
    more_keys = True
    id_list = []
    while more_keys:
        id = input("Enter id or -1 to stop")
        if id == "-1":
            more_keys = False
        else:
            id_list.append(id)
    if len(id_list) > 0:
        payload_dict = {"drip_ids": id_list}
        r1 = requests.post('https://localhost:8080/get/drones', json=payload_dict, verify=False)
        print(r1.status_code)
        print(r1.content)


def get_key():
    """
    Fetches a public key from the database given a drip_id if it exists.
    Prints status and content of response.
    """
    drip_id = input("Enter id: ")
    payload_dict = {"drip_id": drip_id}
    r1 = requests.post('https://localhost:8080/get/key', json=payload_dict, verify=False)
    print(r1.status_code)
    print(r1.content)


def get_all():
    """
    Fetches all drones from database and prints them.
    """
    r1 = requests.get('https://localhost:8080/get/drones/all', verify=False)
    print(r1.status_code)
    print(r1.content)


def main():
    is_running = True
    while is_running:
        choice = input("Select option:\n1:insert drone\n2:get public key from id\n3:get drones from ids\n4:get all drones\n5:Quit")
        if choice == "1":
            insert_drone()
        elif choice == "2":
            get_key()
        elif choice == "3":
            get_drones()
        elif choice == "4":
            get_all()
        elif choice == "5":
            is_running = False
        else:
            print("Invalid option, please select a new one.")


if __name__ == "__main__":
    main()
